<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>
    <script>
    // Function Closure có tham số
    function showMessage(message){
        return function(time){
            for(var i = 1; i <= time; i++ ){
                alert(message+' - Google.com')
            }
        }
    }

    var messageFunc = showMessage('Xin Chào Các Bạn');

    messageFunc(3) // truyền tham số vào cho hàm closure

    // function closure thay đổi biến toàn cục lẫn cục bộ
    function Student(){
        var name="";
        var age='';

        return {
            set: function(in_name, in_age){
                name= in_name;
                age= in_age;
            },
            getName: function(){
                return name;
            },
            getAge: function(){
                return age;
            }
        };
    }
    var studentObj = Student();

    studentObj.set('Truong', '23');
    alert(studentObj.getName())
    alert(studentObj.getAge())

    // Return nhiều  function closure

    function  multiClosure(){
        return{
            func1: function(){
                console.log('Function1')
            },
            func2: function(){
                console.log('Function2')
            } 
        }
    }
    var object = multiClosure();
    object.func1();
    object.func2();

    // độ ưu tiên các biến
        // tạo hàm closure
    var message = 'Biến toàn cục';
    function showMessage1() {
        var message = 'bên cục bộ của hàm cha';
        return function(){
            alert(message);
        };
       
    }   
        // khởi tạo hàm closure
        var messageFunc= showMessage1()
        messageFunc()
    </script>
</body>
</html>